<?php 
class model_component_antivirus extends model {
	protected $user_files;
	protected $base_user_cms_files;
	protected $user_directory_tree;
	protected $base_user_cms_directory_tree;
	protected $excess_files_base_folder;
	protected $excess_files_in_folders;

	public function get_files()
	{
		$user_files=scandir(ROOT_DIR);
		$user_files=array_diff($user_files, array('.','..'));
		$user_files=array_values($user_files);
		foreach ($user_files as $key => $value) {
			$user["$value"]='1';
		}
		$user_files=$user;
		return $user_files;
	}
	public function get_base_user_cms_files()
	{
		$base_user_cms_directory_tree=parse_ini_file('base_user_cms.ini',true);
		$this->base_user_cms_directory_tree=$base_user_cms_directory_tree;
		$base_user_cms_files=$base_user_cms_directory_tree['base'];
		$this->base_user_cms_files=$base_user_cms_files;
		$this->user_directory_tree();
	}

	public function get_excess_files()
	{
		$this->user_files=$this->get_files();
		$this->get_base_user_cms_files();
		$excess_files=array_diff_key($this->user_files, $this->base_user_cms_files);
		$this->excess_files_base_folder=$excess_files;
		return $excess_files;
	}

	public function get_missing_files()
	{
		$missing_files=array_diff_key($this->base_user_cms_files, $this->user_files);
		return $missing_files;
	}

	public function get_write_folders()
	{
		$writable_files=array();
		$user_files=$this->user_files;
		foreach ($user_files as $file => $value) {
			if(is_writable($file)){
				$writable_files[]=$file;
			}
		}
		return $writable_files;
	}

	public function check_mobile_redirect()
	{
		$user_files=$this->user_files;
		$line=array();

		foreach ($user_files as $files => $value){

			$file_extension=".".pathinfo($files, PATHINFO_EXTENSION);
			if(($file_extension=='.php')||($files=='.htaccess')){
				$file=fopen($files,'r');
				$i=0;
				$n=0;
				while(!feof($file)){
					++$i;
					++$n;
					$htacces_code = fgets($file);
					$str_mobile_redirect='HTTP_USER_AGENT';
					if( strpos($htacces_code, $str_mobile_redirect) !== false ) {
		           		$line["$n"]["$files"]['position'] = $i;
		           		$line["$n"]["$files"]['string']=$htacces_code;
		        	}
		        	$str_mobile_redirect='RewriteRule ^(.*)$';
		        	if( strpos($htacces_code, $str_mobile_redirect) !== false ) { 
		           		$line["$n"]["$files"]['position'] = $i;
		           		$line["$n"]["$files"]['string']=$htacces_code;
		        	}
		    	}
		    	fclose($file);
	    	}
    	}
   	return $line;
	}

	public function user_directory_tree()
	{
		$user_files=$this->user_files;
		foreach ($user_files as $key => $value) {
			if(is_dir($key)){
				$user_directory[]=$key;
			}
		}			
		$user_directory=array_values($user_directory);
		
		for ($i=0; $i < count($user_directory) ; $i++) {
			$folder_files=@scandir(ROOT_DIR.'/'.$user_directory[$i]);
			$folder_files=@array_diff($folder_files, array('..','.'));
			$user_directory_tree["$user_directory[$i]"]=$folder_files;	
		}
		$this->user_directory_tree=$user_directory_tree;
	}

	public function get_missing_files_in_directories()
	{
		$user_directory_tree=$this->user_directory_tree;
		$base_user_cms_directory_tree=$this->base_user_cms_directory_tree;
		unset($base_user_cms_directory_tree['base']);
		$missing_folders_base=@array_diff_key($base_user_cms_directory_tree,$user_directory_tree);
		$except_folders_base=@array_diff_key($user_directory_tree,$base_user_cms_directory_tree);

		foreach ($base_user_cms_directory_tree as $key => $value) {
			@natcasesort($user_directory_tree[$key]);
			$user_directory_tree[$key]=@array_values($user_directory_tree[$key]);
			$value=@array_keys($value);
			@natcasesort($value);
			$excess_files=@array_diff($user_directory_tree[$key], $value);
			if(!empty($excess_files)){
				foreach ($excess_files as $key2 => $file) {
					for ($i=0; $i < count($file) ; $i++) {
						$path=ROOT_DIR.'/'.$key.'/'.$file;
						if(is_dir($path)){
							if($key!='themes' && $key!='uploads'){
								$excess_files_in_folders['excess_files_in_folders'][$key]['Папка'][]=$file;
							}
							else{
								continue;
							}
						}
						else{
							$excess_files_in_folders['excess_files_in_folders'][$key]['Файл'][]=$file;
						}
					}
				}
			}
			$missing_files=@array_diff($value,$user_directory_tree[$key]);
			if(!empty($missing_files)){
				foreach ($missing_files as $key3 => $file) {
					$file_extension=pathinfo($file, PATHINFO_EXTENSION);
					if($file_extension==''){
						$missing_files_in_folders['missing_files_in_folders'][$key]['Папка'][]=$file;
					}
					else{
						$missing_files_in_folders['missing_files_in_folders'][$key]['Файл'][]=$file;
					}
				}
			}
		}
		if(empty($excess_files_in_folders)){
			$excess_files_in_folders=array();
		}
		$this->excess_files_in_folders=$excess_files_in_folders;
		if(empty($missing_files_in_folders)){
			$missing_files_in_folders=array();
		}
		$files_in_directories=array_merge($excess_files_in_folders,$missing_files_in_folders);
		return $files_in_directories;
	}
	public function delete_file($path)
	{
		
		if(is_dir($path)){
	   		if ( $content_del_cat = glob( $path.'/*') ){
	      		foreach ( $content_del_cat as $object ){
	         		if ( is_dir( $object ) ) {
	            		$this->delete_file( $object );
	            	}
	         		else {
	            		@chmod( $object, 0777 );
	            		@unlink( $object );
	            	}
	         	}
	      	}
	   		@chmod( $object, 0777 );
	   		$flag=@rmdir( $path );
	   	}
	   	else{
	   		@chmod( $path, 0777 );
	   		$flag=@unlink($path);
	   	}
	   	return $flag;
	}
	public function check_virus_functions()
	{
		$excess_files_base_folder=$this->excess_files_base_folder;
		$excess_files_in_folders=$this->excess_files_in_folders;
		foreach ($excess_files_base_folder as $key => $value) {
			$excess_files['Корневая папка'][]=(string)$key;
		}
		$excess_files_in_folders=array_values($excess_files_in_folders);
		if(!empty($excess_files_in_folders)){
			foreach ($excess_files_in_folders[0] as $key1 => $value) {
				foreach ($value as $key2 => $files) {
					if($key2!='Папка'){
						foreach ($files as $key3 => $file) {
							$path=ROOT_DIR.'/'.$key1.'/'.$file;
							$excess_files[$key1][]=(string)$file;
						}
					}
				}
			}
		
		foreach ($excess_files as $key1 => $value){
			foreach ($value as $key2 => $file) {
				
				if($key1!='Корневая папка'){
					$path=$key1.'/'.$file;
				}
				else{
					$path=$file;
				}
				
				$file_extension=".".pathinfo($path, PATHINFO_EXTENSION);
				$fp=fopen($path,'r');
				$i=0;
				$n=0;
				while(!feof($fp)){
					++$i;
					++$n;
					$fg = fgets($fp);
					$str='exec';
					if( strpos($fg, $str) !== false ) {
		           		$line["$n"]["$key1"]["$file"]['position'] = $i;
		           		$line["$n"]["$key1"]["$file"]['string']=(string)$fg;
		        	}

		        	$str='base64_encode';
		        	if( strpos($fg, $str) !== false ) { 
		           		$line["$n"]["$key1"]["$file"]['position'] = $i;
		           		$line["$n"]["$key1"]["$file"]['string']=(string)$fg;
		        	}
		        	$str='eval';
		        	if( strpos($fg, $str) !== false ) { 
		           		$line["$n"]["$key1"]["$file"]['position'] = $i;
		           		$line["$n"]["$key1"]["$file"]['string']=(string)$fg;
		        	}
		        	$str='mail';
		        	if( strpos($fg, $str) !== false ) { 
		           		$line["$n"]["$key1"]["$file"]['position'] = $i;
		           		$line["$n"]["$key1"]["$file"]['string']=(string)$fg;
		        	}
		    	}
		    	fclose($fp);
			}
    	}
    	}
    	return @$line;
	}
	public function check_admin_users()
	{
		$sql=$this->dbh->prepare('SELECT id, login,email FROM users WHERE access_level = 2 AND active = 1');
		$sql->execute();
		$sql=$sql->fetchAll();
		return $sql;
	}
	public function check_backup()
	{
		$backups=scandir(ROOT_DIR.'/temp/backups/');
		$backups=array_diff($backups, array('.','..'));
		$backups=array_values($backups);
			$last_backup=strtotime("-1 month");
			$last_backup=date("d-m-Y",$last_backup);
			$max='';
			foreach ($backups as $key => $file) {
				$path=ROOT_DIR.'/temp/backups/'.$file;
				$time=date ("d-m-Y", filemtime($path));
				if(strtotime($time)>strtotime($max)){
					$max=$time;
				}
			}
			if(strtotime($last_backup)>strtotime($max)){
				return $max;
			}
			else{
				return 1;
			}

	}
}





 ?>